# Enum Class CJ1TypePackageVersionBehavior

java.lang.Object
java.lang.Enum<CJ1TypePackageVersionBehavior>
com.io7m.cardant.protocol.inventory.json.internal.CJ1TypePackageVersionBehavior

All Implemented Interfaces:
  `Serializable`, `Comparable<CJ1TypePackageVersionBehavior>`, `Constable`

@JsonClassDescription("Type package version behavior.") public enum CJ1TypePackageVersionBehavior extends Enum<CJ1TypePackageVersionBehavior>
The type removal behavior for package upgrades/uninstalls.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VERSION_ALLOW_DOWNGRADES`
  Allow moving from any version to a lower version.
  `VERSION_DISALLOW_DOWNGRADES`
  Disallow moving from any version to a lower version.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static CJ1TypePackageVersionBehavior`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static CJ1TypePackageVersionBehavior[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VERSION_ALLOW_DOWNGRADES

    public static final CJ1TypePackageVersionBehavior VERSION_ALLOW_DOWNGRADES
    Allow moving from any version to a lower version.

  - ### VERSION_DISALLOW_DOWNGRADES

    public static final CJ1TypePackageVersionBehavior VERSION_DISALLOW_DOWNGRADES
    Disallow moving from any version to a lower version.

- ## Method Details

  - ### values

    public static CJ1TypePackageVersionBehavior[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static CJ1TypePackageVersionBehavior valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null